<?php

namespace IPS\memberaway\extensions\core\MemberHistory;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _memberAway
{
	public function getTypes()
	{
		return array(
			'set_away_status',
			'unset_away_status'
		);
	}

	public function parseLogData( $value, $row )
	{
		$jsonValue = json_decode( $value, TRUE );

		switch( $row['log_type'] )
		{
			case 'set_away_status':
				return \IPS\Member::loggedIn()->language()->addToStack( 'ma_history_set_status' );
			break;
			case 'unset_away_status':
				return \IPS\Member::loggedIn()->language()->addToStack( 'ma_history_unset_status' );
			break;
		}

		return $value;
	}

	public function parseLogType( $value, $row )
	{
		return \IPS\Theme::i()->getTemplate( 'members', 'memberaway' )->logType( $value );
	}
}