<?php

namespace IPS\memberaway\extensions\core\ModCpMemberManagement;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _Away
{
	public function getTab()
	{
		if( !\IPS\Member::loggedIn()->modPermission( 'memberaway_manage' ) )
		{
			return null;
		}

		return 'away';
	}

	public function manage()
	{
		if( ! \IPS\Member::loggedIn()->modPermission( 'memberaway_manage' ) )
		{
			\IPS\Output::i()->error( 'no_module_permission', 'MEMBER AWAY - MODCP/1', 403, '' );
		}

		$table = new \IPS\memberaway\Table( 'memberaway_data', \IPS\Http\Url::internal( 'app=core&module=modcp&controller=modcp&tab=members&area=away' ), 'ma_on=1' );
		$table->limit = 10;
		$table->tableTemplate = array( \IPS\Theme::i()->getTemplate( 'modcp', 'memberaway', 'front' ), 'memberAwayTable' );
		$table->rowsTemplate = array( \IPS\Theme::i()->getTemplate( 'modcp', 'memberaway', 'front' ), 'memberAwayRows' );

		$table->sortBy = $table->sortBy ?: 'ma_date';
		$table->sortDirection = $table->sortDirection ?: 'desc';

		return (string) $table;
	}
}