//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class memberaway_hook_maProfileController extends _HOOK_CLASS_
{
	protected function getAwayReason()
	{
		try
		{
			try
			{
				$reason = NULL;
				$date   = time();
		
				try
				{
					$status = \IPS\memberaway\Status::load( \IPS\Request::i()->mid );
					$reason = $status->text ?: NULL;
					$date	= $status->date;
				}
				catch( \OutOfRangeException $e ){}
		
				\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate( 'profile', 'memberaway', 'front' )->memberAwayViewReason( $reason, $date );
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	protected function enableStatus()
	{
		try
		{
			try
			{
				if( !\IPS\Member::loggedIn()->modPermission( 'memberaway_manage' ) )
				{
					\IPS\Output::i()->error( 'no_module_permission', 'MEMBER AWAY - ENABLE AWAY STATUS IN PROFILE/1', 403, '' );
				}
		
				if( !\IPS\Settings::i()->ma_mods_other_users AND $this->member->member_id != \IPS\Member::loggedIn()->member_id )
				{
					\IPS\Output::i()->error( 'no_module_permission', 'MEMBER AWAY - ENABLE AWAY STATUS IN PROFILE/2', 403, '' );
				}
		
				$form = new \IPS\Helpers\Form;
				$form->class = 'ipsForm_collapseTablet';
		
				$form->add( new \IPS\Helpers\Form\YesNo( 'membersaway_on', FALSE, FALSE, array( 'togglesOn' => array( 'membersAway_days', 'membersaway_text' ) ) ) );
				$form->add( new \IPS\Helpers\Form\Date( 'membersAway_days', NULL, TRUE, array( 'min' => \IPS\DateTime::create(), 'max' => \IPS\DateTime::create()->add( new \DateInterval( 'P'. \IPS\Settings::i()->ma_days . 'D' ) ), 'time' => TRUE ), NULL, NULL, NULL, 'membersAway_days' ) );
				$form->add( new \IPS\Helpers\Form\Editor( 'membersaway_text', NULL, \IPS\Settings::i()->ma_reasonrequired ? TRUE: FALSE, array( 'app' => 'memberaway', 'key' => 'memberAway', 'autoSaveKey' => "membersaway_text_"  . $this->member->member_id, 'attachIds' => NULL, 'minimize' => 'membersAway_text_placeholder' ), NULl, NULL, NULL, 'membersaway_text' ) );
		
				if( $values = $form->values() )
				{
					$status  = new \IPS\memberaway\Status;
		
					$status->mid  = $this->member->member_id;
					$status->on   = $values['membersaway_on'];
					$status->text = $values['membersaway_text'];
					$status->date = $values['membersAway_days']->getTimestamp();
		
					$status->save();
		
					\IPS\Session::i()->modLog( sprintf( 'away_status_added_to', $this->member->name ), array( $this->member->name => FALSE, $this->member->member_id => FALSE ) );
		
					\IPS\Output::i()->redirect( $this->member->url(), 'saved' );
				}
		
				\IPS\Output::i()->output = $form->customTemplate( array( \IPS\Theme::i()->getTemplate( 'forms', 'core' ), 'popupTemplate' ) );
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	protected function enableStatusFromProfile()
	{
		try
		{
			try
			{
				if( !\IPS\Member::loggedIn()->modPermission( 'memberaway_manage' ) )
				{
					\IPS\Output::i()->error( 'no_module_permission', 'MEMBER AWAY - REMOVE AWAY STATUS IN PROFILE/1', 403, '' );
				}
		
				if( !\IPS\Settings::i()->ma_mods_other_users AND $this->member->member_id != \IPS\Member::loggedIn()->member_id )
				{
					\IPS\Output::i()->error( 'no_module_permission', 'MEMBER AWAY - REMOVE AWAY STATUS IN PROFILE/2', 403, '' );
				}
		
				$status = \IPS\memberaway\Status::load( $this->member->member_id );
				$status->delete();
		
				\IPS\Session::i()->modLog( sprintf( 'away_status_toggled_from', $this->member->name ), array( $this->member->name => FALSE, $this->member->member_id => FALSE ) );
				\IPS\Output::i()->redirect( $this->member->url(), 'away_status_toggled_done' );
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	protected function removeStatus()
	{
		try
		{
			try
			{
				if( !\intval( \IPS\Request::i()->mid ) OR !\IPS\Member::loggedIn()->modPermission( 'memberaway_manage' ) )
				{
					\IPS\Output::i()->error( 'no_module_permission', 'MEMBER AWAY - REMOVE AWAY STATUS/1', 403, '' );
				}
		
				$status = \IPS\memberaway\Status::load( \IPS\Request::i()->mid );
				$status->delete();
		
				$member = \IPS\Member::load( \IPS\Request::i()->mid );
				\IPS\Session::i()->modLog( sprintf( 'away_status_toggled_from', $member->name ), array( $member->name => FALSE, $member->member_id => FALSE ) );
		
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( "app=core&module=modcp&tab=members&area=away", 'front', 'modcp_members' ), 'away_status_toggled_done' );
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}