//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class memberaway_hook_maSettings extends _HOOK_CLASS_
{
	protected function _memberaway()
	{
		try
		{
			try
			{
				if( !( \IPS\Settings::i()->ma_groups == '*' OR \IPS\Member::loggedIn()->inGroup( explode( ',', \IPS\Settings::i()->ma_groups ) ) ) )
				{
					\IPS\Output::i()->error( 'no_module_permission', 'MEMBER AWAY - ACCOUNT SETTINGS/1', 403, '' );
				}
		
				try
				{
					$status  = \IPS\memberaway\Status::load( \IPS\Member::loggedIn()->member_id );
				}
				catch( \OutOfRangeException $e )
				{
					$status = NULL;
				}
		
				$form = NULL;
				if( !isset( $status ) )
				{
					$form = new \IPS\Helpers\Form;
					$form->class = 'ipsForm_collapseTablet';
		
					$validation = function( $val )
					{
						if( !$val )
						{
							throw new \DomainException( 'ma_not_enabled' );
						}
					};
					$form->add( new \IPS\Helpers\Form\YesNo( 'membersaway_on', isset( $status ) ? $status->on : FALSE, FALSE, array( 'togglesOn' => array( 'membersAway_days', 'membersaway_text' ) ), $validation ) );
		
					$disabled = isset( $status ) AND $status->on AND $status->text AND $status->days > 0 ? TRUE : FALSE;
					$form->add( new \IPS\Helpers\Form\Date( 'membersAway_days', NULL, TRUE, array( 'min' => \IPS\DateTime::create(), 'max' => \IPS\DateTime::create()->add( new \DateInterval( 'P'. \IPS\Settings::i()->ma_days . 'D' ) ), 'time' => TRUE ), NULL, NULL, NULL, 'membersAway_days' ) );
					$form->add( new \IPS\Helpers\Form\Editor( 'membersaway_text', isset( $status ) ? $status->text : NULL, \IPS\Settings::i()->ma_reasonrequired ? TRUE: FALSE, array( 'app' => 'memberaway', 'key' => 'memberAway', 'autoSaveKey' => "membersaway_text_"  . \IPS\Member::loggedIn()->member_id, 'attachIds' => NULL, 'minimize' => 'membersAway_text_placeholder' ), NULl, NULL, NULL, 'membersaway_text' ) );
		
					if( $values = $form->values() )
					{
						if( isset( $status ) )
						{
							$status->on = $values['membersaway_on'];
							$status->text = $values['membersaway_text'];
							$status->date = $values['membersAway_days']->getTimestamp();
						}
						else
						{
							$status  = new \IPS\memberaway\Status;
							$status->mid  = \IPS\Member::loggedIn()->member_id;
							$status->on   = $values['membersaway_on'];
							$status->text = $values['membersaway_text'];
							$status->date = $values['membersAway_days']->getTimestamp();
						}
						$status->save();
		
						\IPS\Member::loggedIn()->logHistory( 'memberaway', 'set_away_status' );
		
						\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=core&module=system&controller=settings&area=memberaway', 'front', 'settings_memberaway' ), 'saved' );
					}
				}
		
				return \IPS\Theme::i()->getTemplate( 'settings', 'memberaway', 'front' )->settingsMemberAway( $form );
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	protected function removeAwayStatus()
	{
		try
		{
			try
			{
				try
				{
					$status  = \IPS\memberaway\Status::load( \IPS\Member::loggedIn()->member_id );
					$status->delete();
				}
				catch( \OutOfRangeException $e ){}
		
				\IPS\Member::loggedIn()->logHistory( 'memberaway', 'unset_away_status' );
		
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=core&module=system&controller=settings&area=memberaway', 'front', 'settings_memberaway' ), 'away_status_toggled_done' );
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}