<?php

namespace IPS\memberaway\modules\admin\memberaway;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _settings extends \IPS\Dispatcher\Controller
{
	protected function manage()
	{
		\IPS\Dispatcher::i()->checkAcpPermission( 'settings_manage' );
	
		$form = new \IPS\Helpers\Form;
		$form->add( new \IPS\Helpers\Form\Number( 'ma_days', \IPS\Settings::i()->ma_days, FALSE, array( 'min' => 1, 'max' => 180 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack('days'), 'ma_days' ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ma_dateFormat', \IPS\Settings::i()->ma_dateFormat ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ma_reasonrequired', \IPS\Settings::i()->ma_reasonrequired ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ma_userinfopane', \IPS\Settings::i()->ma_userinfopane ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ma_globalwarn', \IPS\Settings::i()->ma_globalwarn ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ma_faicon_username', \IPS\Settings::i()->ma_faicon_username ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ma_mods_other_users', \IPS\Settings::i()->ma_mods_other_users ) );
		$form->add( new \IPS\Helpers\Form\CheckboxSet( 'ma_groups', \IPS\Settings::i()->ma_groups != '*' ? explode( ",", \IPS\Settings::i()->ma_groups ) : '*', FALSE, array( 'options' => \IPS\Member\Group::groups( TRUE, FALSE ), 'parse' => 'normal', 'multiple' => true ), NULL, NULL, NULL, 'ma_groups' ) );

		if( $values = $form->values( TRUE ) )
		{
			$form->saveAsSettings( $values );
			\IPS\Session::i()->log( 'acplogs__memberaway_settings' );
		}
	
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('settings');
		\IPS\Output::i()->output = $form;
	}
}