<?php

namespace IPS\memberaway;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _Table extends \IPS\Helpers\Table\Db
{
	public function __construct( $table, \IPS\Http\Url $baseUrl, $where=NULL, $forceIndex=NULL )
	{
		if( isset( \IPS\Request::i()->modaction ) )
		{
			$this->multiMod();
		}

		return parent::__construct( $table, $baseUrl, $where, $forceIndex );
	}

	public $showFilters	= TRUE;
	public $savedActions = array();

	public function getFilters()
	{
		return array();
	}

	public function canModerate( $action=NULL )
	{
		if( \IPS\Member::loggedIn()->modPermission('memberaway_manage') )
		{
			return TRUE;
		}

		return FALSE;
	}

	public function multimodActions()
	{
		return array( 'toggle' );
	}

	protected function multimod()
	{
		if( !\is_array( \IPS\Request::i()->moderate ) )
		{
			return;
		}

		\IPS\Session::i()->csrfCheck();

		$ids = array();
		foreach( \IPS\Request::i()->moderate AS $id => $members )
		{
			$ids[] = $id;
		}

		switch( \IPS\Request::i()->modaction )
		{
			case 'toggle':
				foreach( $ids as $id )
				{
					$member = \IPS\Member::load( $id );
					\IPS\Session::i()->modLog( 'away_status_toggled_from', array( $member->name => FALSE ) );
					\IPS\Db::i()->delete( 'memberaway_data', array( 'ma_mid=?', $member->member_id ) );
				}
			break;
		}

		\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=core&module=modcp&controller=modcp&tab=members&area=away', 'front', 'modcp_members' ), 'completed' );
	}
}